# -*- coding:utf-8 -*-

# Q's Web Diary
# Copyright (c) 2001,2011 HORIKAWA Hisashi. All rights reserved.
#   http://www.nslabs.jp/
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


# エントリに付けるタグ
class TagsController < ApplicationController
  # GET /tags
  # GET /tags.xml
  def index
    @blog = params[:blog_id].blank? ? nil : (Blog.find params[:blog_id])
    if @blog
      @ets = EntriesTag.find :all, 
                       :select => "DISTINCT entries_tags.tag_id",
                       :joins => "LEFT JOIN entries ON entries_tags.entry_id = entries.id LEFT JOIN blogs ON entries.blog_id = blogs.id",
                       :conditions => ["blogs.id = ?", @blog.id]
    else
      @ets = EntriesTag.find :all,
                       :select => "DISTINCT entries_tags.tag_id"
    end
  end


  # タグを含むエントリの一覧 (公開ページ)
  def show
    @blog = params[:blog_id].blank? ? nil : (Blog.find params[:blog_id])
    @tag = Tag.find params[:id]

    if @blog
      @entries = Entry.find :all,
                    :select => "DISTINCT entries.*",
                    :joins => "LEFT JOIN entries_tags ON entries.id = entries_tags.entry_id",
                    :conditions => ["entries.blog_id = ? AND entries.status <> 0 AND entries.date <= ? AND entries_tags.tag_id = ?", 
                                    @blog.id, Date.today, @tag.id]
    else
      raise # TODO:
    end

    render :layout => "tdiary"
  end


=begin
  # GET /tags/new
  # GET /tags/new.xml
  def new
    @tag = Tag.new

    respond_to do |format|
      format.html # new.html.erb
      format.xml  { render :xml => @tag }
    end
  end

  # GET /tags/1/edit
  def edit
    @tag = Tag.find(params[:id])
  end

  # POST /tags
  # POST /tags.xml
  def create
    @tag = Tag.new(params[:tag])

    respond_to do |format|
      if @tag.save
        format.html { redirect_to(@tag, :notice => 'Tag was successfully created.') }
        format.xml  { render :xml => @tag, :status => :created, :location => @tag }
      else
        format.html { render :action => "new" }
        format.xml  { render :xml => @tag.errors, :status => :unprocessable_entity }
      end
    end
  end

  # PUT /tags/1
  # PUT /tags/1.xml
  def update
    @tag = Tag.find(params[:id])

    respond_to do |format|
      if @tag.update_attributes(params[:tag])
        format.html { redirect_to(@tag, :notice => 'Tag was successfully updated.') }
        format.xml  { head :ok }
      else
        format.html { render :action => "edit" }
        format.xml  { render :xml => @tag.errors, :status => :unprocessable_entity }
      end
    end
  end
=end


  # DELETE /tags/1
  # DELETE /tags/1.xml
  def destroy
    @tag = Tag.find(params[:id])
    @tag.destroy

    respond_to do |format|
      format.html { redirect_to(tags_url) }
      format.xml  { head :ok }
    end
  end
end
